var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import uuid from 'uuid/v4';
import Draggable from 'react-draggable';
import { Container, Layout, Separator, Widget, WidgetTabs, Dropzones } from './components';
import { WidgetTab, WidgetTabDropzone, Dropzone, WidgetLastTabDropzone } from './dnd';
import debounce from 'lodash/debounce';
var ROOT = 'root';
var BORDER_SIZE = 4;
var Advanced = /** @class */ (function (_super) {
    __extends(Advanced, _super);
    function Advanced() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.createReactRef = function (instance) { return (_this.layout = instance); };
        _this.state = {
            width: 0,
            height: 0
        };
        _this.createOnDragStop = function (prevId, nextId, prevPercent, nextPercent, nextValue, isVertical) { return function (e, _a) {
            var x = _a.x, y = _a.y;
            var offset = isVertical ? x : y;
            var newNextPercent = Math.trunc(((nextValue - offset) * nextPercent) / nextValue);
            if (newNextPercent < 10) {
                newNextPercent = 10;
            }
            else if (newNextPercent > prevPercent + nextPercent - 10) {
                newNextPercent = prevPercent + nextPercent - 10;
            }
            var newPrevPercent = prevPercent + nextPercent - newNextPercent;
            if (isVertical) {
                _this.props.onChangeWidth(prevId, newPrevPercent, nextId, newNextPercent);
            }
            else {
                _this.props.onChangeHeight(prevId, newPrevPercent, nextId, newNextPercent);
            }
        }; };
        _this.createOnTabDrop = function (containerId, nextWidget) { return function (_a) {
            var widgetId = _a.widgetId, registeredWidgetId = _a.registeredWidgetId;
            var _widgetId = widgetId;
            if (!_widgetId) {
                _widgetId = uuid();
                _this.props.onCreateWidget(_widgetId, registeredWidgetId);
            }
            else {
                _this.props.onRemoveWidget(_widgetId);
            }
            _this.props.onAddWidgetToTab(containerId, nextWidget, _widgetId);
        }; };
        _this.createOnContainerDrop = function (containerId, position) { return function (_a) {
            var widgetId = _a.widgetId, registeredWidgetId = _a.registeredWidgetId;
            var _widgetId = widgetId;
            if (!_widgetId) {
                _widgetId = uuid();
                _this.props.onCreateWidget(_widgetId, registeredWidgetId);
            }
            else {
                _this.props.onRemoveWidget(_widgetId);
            }
            _this.props.onAddWidget(containerId, position, _widgetId);
        }; };
        _this.createOnClose = function (widgetId) { return function () {
            _this.props.onRemoveWidget(widgetId);
        }; };
        _this.createOnClick = function (containerId, widgetId) { return function () {
            _this.props.onChangeActiveTab(containerId, widgetId);
        }; };
        _this.renderContainer = function (containerId, width, height) {
            var structure = _this.props.structure;
            var container = structure[containerId];
            var isVertical = container.isVertical;
            var hasWidgets = !!container.widgets;
            var hasContainers = !!container.containers;
            return (React.createElement(Container, { containerWidth: width, containerHeight: height, key: containerId, isVertical: isVertical, hasWidgets: hasWidgets },
                hasContainers &&
                    _this.renderContainers(container.containers, isVertical, width, height, containerId),
                hasWidgets && _this.renderTabs(containerId, container.widgets),
                hasWidgets && _this.renderActiveWidget(containerId),
                hasWidgets &&
                    width > 100 &&
                    height > 100 && (React.createElement(Dropzones, { dropzoneWidth: width }, _this.renderDropzones(containerId, width, height)))));
        };
        _this.renderContainers = function (containers, isVertical, width, height, containerId) {
            var structure = _this.props.structure;
            return containers.reduce(function (current, id, index, ids) {
                var item = structure[id];
                var calculatedWidth = (width - (isVertical ? (ids.length - 1) * BORDER_SIZE : 0)) * ((item.width || 100) / 100);
                var calculatedHeight = (height - (!isVertical ? (ids.length - 1) * BORDER_SIZE : 0)) *
                    ((item.height || 100) / 100);
                if (index !== 0) {
                    var prevId = ids[index - 1];
                    var prevPercent = isVertical ? structure[prevId].width : structure[prevId].height;
                    var nextPercent = isVertical ? item.width : item.height;
                    var nextValue = isVertical ? calculatedWidth : calculatedHeight;
                    current.push(React.createElement(Draggable, { bounds: "parent", key: "separator_" + containerId + "_" + index, position: { x: 0, y: 0 }, onStop: _this.createOnDragStop(prevId, id, prevPercent, nextPercent, nextValue, isVertical) },
                        React.createElement(Separator, { isVertical: isVertical })));
                }
                current.push(_this.renderContainer(id, calculatedWidth, calculatedHeight));
                return current;
            }, []);
        };
        _this.renderTabs = function (containerId, widgets) { return (React.createElement(WidgetTabs, null,
            widgets.map(function (item, index) { return (React.createElement(WidgetTab, { containerId: containerId, isLastTab: index === widgets.length - 1, isLonelyTab: widgets.length === 1, key: item, widgetId: item, onClose: _this.createOnClose(item), isActive: _this.props.activeTabs[containerId] === item, onClick: _this.createOnClick(containerId, item) },
                _this.props.getWidgetName(item),
                React.createElement(WidgetTabDropzone, { onTabDrop: _this.createOnTabDrop(containerId, item), widgetId: item, containerId: containerId }))); }),
            React.createElement(WidgetLastTabDropzone, { containerId: containerId, onTabDrop: _this.createOnTabDrop(containerId) }))); };
        _this.renderActiveWidget = function (containerId) {
            var _a = _this.props, activeTabs = _a.activeTabs, getWidgetRenderedComponent = _a.getWidgetRenderedComponent;
            return React.createElement(Widget, null, getWidgetRenderedComponent(activeTabs[containerId]));
        };
        _this.renderDropzones = function (containerId, width, height) {
            var positions = ['bottom', 'top', 'left', 'right'];
            return (React.createElement(React.Fragment, null, positions.map(function (position) {
                var isRoot = containerId === 'root';
                var dropzoneWidth = position === 'left' || position === 'right'
                    ? isRoot
                        ? 16
                        : Math.trunc(width / 4)
                    : width;
                var dropzoneHeight = position === 'top' || position === 'bottom'
                    ? isRoot
                        ? 16
                        : Math.trunc(height / 2)
                    : height;
                return (React.createElement(Dropzone, { key: position, containerId: containerId, onContainerDrop: _this.createOnContainerDrop(containerId, position), position: position, dropzoneWidth: dropzoneWidth, dropzoneHeight: dropzoneHeight, zIndex: isRoot ? 101 : 100 }));
            })));
        };
        return _this;
    }
    Advanced.prototype.render = function () {
        var _a = this.state, width = _a.width, height = _a.height;
        var sizeCalculated = !!width && !!height;
        var hasContainers = this.props.structure.root.containers.length > 0;
        return (React.createElement(Layout, { innerRef: this.createReactRef }, sizeCalculated && (React.createElement(React.Fragment, null,
            hasContainers && (React.createElement(React.Fragment, null,
                this.renderDropzones(ROOT, width, height),
                this.renderContainer(ROOT, width, height))),
            !hasContainers && (React.createElement(Dropzone, { containerId: ROOT, onContainerDrop: this.createOnContainerDrop(ROOT, 'center'), position: "center", dropzoneWidth: width, dropzoneHeight: height }))))));
    };
    Advanced.prototype.componentDidMount = function () {
        var _this = this;
        this.setState({
            width: this.layout.offsetWidth,
            height: this.layout.offsetHeight
        });
        window.onresize = debounce(function () {
            return _this.setState({
                width: _this.layout.offsetWidth,
                height: _this.layout.offsetHeight
            });
        }, 50);
    };
    return Advanced;
}(React.Component));
export default Advanced;
//# sourceMappingURL=TabWidget.js.map