var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
import TabWidget from './TabWidget';
import update from 'immutability-helper';
import uuid from 'uuid/v4';
var ReactTabWidgetContainer = /** @class */ (function (_super) {
    __extends(ReactTabWidgetContainer, _super);
    function ReactTabWidgetContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            widgets: {},
            activeTabs: {},
            structure: {
                root: {
                    isVertical: true,
                    containers: []
                }
            }
        };
        _this.normalize = function (structure) {
            var normalized = {};
            var ratios = {};
            var normalizeContainer = function (id) {
                var _a = __assign({}, structure[id]), containers = _a.containers, container = __rest(_a, ["containers"]);
                if (containers) {
                    container.containers = containers.slice();
                    var _loop_1 = function (i) {
                        var _a;
                        var childId = container.containers[i];
                        var child = __assign({}, structure[childId]);
                        if (container.isVertical === child.isVertical && !!child.containers) {
                            (_a = container.containers).splice.apply(_a, [i, 1].concat(child.containers));
                            var field_1 = container.isVertical ? 'width' : 'height';
                            // memoize ratios to calculate nested containers size
                            child.containers.forEach(function (item) {
                                ratios[item] = ratios[childId]
                                    ? (child[field_1] * ratios[childId]) / 100
                                    : child[field_1];
                            });
                        }
                        else {
                            i++;
                        }
                        out_i_1 = i;
                    };
                    var out_i_1;
                    for (var i = 0; i < container.containers.length;) {
                        _loop_1(i);
                        i = out_i_1;
                    }
                    container.containers.forEach(normalizeContainer);
                }
                normalized[id] = container;
            };
            normalizeContainer('root');
            // calculate actual sizes considering ratio
            Object.keys(normalized).forEach(function (key) {
                if (!ratios[key]) {
                    return;
                }
                var field = normalized[key].height ? 'height' : 'width';
                normalized[key][field] = Math.trunc((normalized[key][field] * ratios[key]) / 100);
            });
            // calculate first container's size (remainder to fill 100)
            Object.keys(normalized).forEach(function (key) {
                if ((normalized[key].containers || []).length === 0) {
                    return;
                }
                var field = normalized[key].isVertical ? 'width' : 'height';
                var sum = normalized[key].containers.reduce(function (current, item, index) {
                    if (index === 0) {
                        return current;
                    }
                    return current + normalized[item][field];
                }, 0);
                normalized[normalized[key].containers[0]][field] = 100 - sum;
            });
            return normalized;
        };
        _this.changeWidth = function (prevId, prevValue, nextId, nextValue) {
            _this.setState(function (state) {
                var _a;
                return update(state, {
                    structure: (_a = {},
                        _a[prevId] = {
                            width: {
                                $set: prevValue
                            }
                        },
                        _a[nextId] = {
                            width: {
                                $set: nextValue
                            }
                        },
                        _a)
                });
            });
        };
        _this.changeHeight = function (prevId, prevValue, nextId, nextValue) {
            _this.setState(function (state) {
                var _a;
                return update(state, {
                    structure: (_a = {},
                        _a[prevId] = {
                            height: {
                                $set: prevValue
                            }
                        },
                        _a[nextId] = {
                            height: {
                                $set: nextValue
                            }
                        },
                        _a)
                });
            });
        };
        _this.createWidget = function (widgetId, registeredWidgetId) {
            _this.setState(function (state) {
                var _a;
                return update(state, {
                    widgets: (_a = {},
                        _a[widgetId] = {
                            $set: {
                                widget: registeredWidgetId,
                                props: {
                                    newWidget: true
                                }
                            }
                        },
                        _a)
                });
            }, function () {
                if (_this.props.onWidgetCreated) {
                    _this.props.onWidgetCreated(widgetId, registeredWidgetId);
                }
            });
        };
        _this.removeWidget = function (widgetId) {
            _this.setState(function (state) {
                var _a, _b, _c;
                var id = Object.keys(state.structure).find(function (key) { return (state.structure[key].widgets || []).indexOf(widgetId) !== -1; });
                var widgets = (state.structure[id].widgets || []).filter(function (item) { return item !== widgetId; });
                if (widgets.length > 0) {
                    var structure = _this.normalize(update(state.structure, (_a = {},
                        _a[id] = {
                            widgets: {
                                $set: widgets
                            }
                        },
                        _a)));
                    var activeTab = widgetId === state.activeTabs[id]
                        ? (state.structure[id].widgets || [])[0]
                        : state.activeTabs[id];
                    return update(state, {
                        structure: {
                            $set: structure
                        },
                        activeTabs: (_b = {},
                            _b[id] = {
                                $set: activeTab
                            },
                            _b)
                    });
                }
                var findContainer = function (child) {
                    return Object.keys(state.structure).find(function (key) { return (state.structure[key].containers || []).indexOf(child) !== -1; });
                };
                var containerId = findContainer(id);
                var childId = id;
                while (containerId !== 'root' &&
                    (state.structure[containerId].containers || []).length === 1) {
                    childId = containerId;
                    containerId = findContainer(containerId);
                }
                return __assign({}, state, { structure: _this.normalize(update(state.structure, (_c = {},
                        _c[containerId] = {
                            containers: {
                                $apply: function (value) { return value.filter(function (item) { return item !== childId; }); }
                            }
                        },
                        _c))) });
            });
        };
        _this.addWidget = function (containerId, position, widgetId) {
            _this.setState(function (state) {
                var _a, _b, _c, _d, _e, _f;
                var isVertical = position === 'left' || position === 'right';
                var newContainerId = uuid();
                var newContainer = (_a = {
                        widgets: [widgetId]
                    },
                    _a[isVertical ? 'width' : 'height'] = 50,
                    _a);
                if (position === 'center') {
                    newContainer[isVertical ? 'width' : 'height'] = 100;
                    return update(state, {
                        structure: (_b = {},
                            _b[containerId] = {
                                $set: {
                                    isVertical: isVertical,
                                    containers: [newContainerId]
                                }
                            },
                            _b[newContainerId] = {
                                $set: newContainer
                            },
                            _b),
                        activeTabs: (_c = {},
                            _c[newContainerId] = {
                                $set: widgetId
                            },
                            _c)
                    });
                }
                var oldContainerId = uuid();
                var oldContainer = __assign({}, state.structure[containerId], (_d = {}, _d[isVertical ? 'width' : 'height'] = 50, _d[isVertical ? 'height' : 'width'] = undefined, _d));
                var containers = position === 'left' || position === 'top'
                    ? [newContainerId, oldContainerId]
                    : [oldContainerId, newContainerId];
                var structure = _this.normalize(update(state.structure, (_e = {},
                    _e[containerId] = {
                        $set: {
                            width: state.structure[containerId].width,
                            height: state.structure[containerId].height,
                            isVertical: isVertical,
                            containers: containers
                        }
                    },
                    _e[newContainerId] = {
                        $set: newContainer
                    },
                    _e[oldContainerId] = {
                        $set: oldContainer
                    },
                    _e)));
                return update(state, {
                    structure: {
                        $set: structure
                    },
                    activeTabs: (_f = {},
                        _f[newContainerId] = { $set: widgetId },
                        _f[oldContainerId] = {
                            $set: state.activeTabs[containerId]
                        },
                        _f)
                });
            });
        };
        _this.addWidgetToTab = function (containerId, nextWidgetId, widgetId) {
            _this.setState(function (state) {
                var _a, _b;
                var widgets = state.structure[containerId].widgets || [];
                var indexToInsert = nextWidgetId ? widgets.indexOf(nextWidgetId) : widgets.length;
                return update(state, {
                    structure: (_a = {},
                        _a[containerId] = {
                            widgets: {
                                $apply: function (values) {
                                    var newValues = values.slice();
                                    newValues.splice(indexToInsert, 0, widgetId);
                                    return newValues;
                                }
                            }
                        },
                        _a),
                    activeTabs: (_b = {},
                        _b[containerId] = {
                            $set: widgetId
                        },
                        _b)
                });
            });
        };
        _this.changeActiveTab = function (containerId, widgetId) {
            _this.setState(function (state) {
                var _a;
                return update(state, {
                    activeTabs: (_a = {},
                        _a[containerId] = {
                            $set: widgetId
                        },
                        _a)
                });
            });
        };
        return _this;
    }
    ReactTabWidgetContainer.prototype.render = function () {
        var _a = this.state, structure = _a.structure, widgets = _a.widgets, activeTabs = _a.activeTabs;
        var _b = this.props, getWidgetName = _b.getWidgetName, getWidgetRenderedComponent = _b.getWidgetRenderedComponent;
        return (React.createElement(TabWidget, { getWidgetName: getWidgetName, getWidgetRenderedComponent: getWidgetRenderedComponent, structure: structure, widgets: widgets, activeTabs: activeTabs, onChangeHeight: this.changeHeight, onChangeWidth: this.changeWidth, onCreateWidget: this.createWidget, onRemoveWidget: this.removeWidget, onAddWidget: this.addWidget, onAddWidgetToTab: this.addWidgetToTab, onChangeActiveTab: this.changeActiveTab }));
    };
    return ReactTabWidgetContainer;
}(React.Component));
export default ReactTabWidgetContainer;
//# sourceMappingURL=TabWidgetContainer.js.map